/*------------------------------------------------------------
          LanMon
 6  8.04.2011
lanmon@mnppsaturn.ru

       SystemADOConnection1
TrendFlatIntervalMode       :
  false -  ( ), true - 

:
  Draw3Trend -  3      lanmon:
  bool Draw3Trend(WORD A1, WORD A2, WORD A3, WORD A4_1, WORD A4_2, WORD A4_3,
                  int TrendType, String Template, int ArcIndex,
                  int GraphIndex = 0, String Caption="");
    A1,A2,A3,A4_1 -   1
    A1,A2,A3,A4_2 -   2
    A1,A2,A3,A4_3 -   3
     A4_2==0     
     A4_3==0     
    TrendType  : 0-  1-  2- 
    Template -     .grf
    ArcIndex -    1  99
    GraphIndex -  ,      0  9
    Caption -   .    -    .
  DrawTrend -       lanmon
  Draw2Trend -  2      lanmon
------------------------------------------------------------*/

#define szTrendErrorCaption "   "
#define TrendFlatIntervalMode true

//  
//  3 ,     
WORD trendA1, trendA2, trendA3, trendA4_1, trendA4_2, trendA4_3;
//   : 0-  1-  2- 
int TrendTypeCurrent;
//     
TDateTime TrendStartTime, TrendEndTime;
// Custom   
String CustomTrendCaption;
// -    SQL   
int TrendValuesCount;
TDateTime TrendStartTimePoint;

//------------------------------------------------------------
//       
//------------------------------------------------------------
void DeleteTrendFiles()
{
  DeleteFile(LMWorkDir() + "TREND\\*.*");
}

//------------------------------------------------------------
//    :  -10%  +10%
//       TrendAssign()
//------------------------------------------------------------
void FormatValueAxis()
{
  double MinValue, MaxValue, v;
  TrendGetMinMax(MinValue, MaxValue);
  GraphSetup.LeftAxisAutomatic = false;
  v = Abs(MaxValue - MinValue) / 10.0;
  //if( v<0.5 )   v = 0.5;
  GraphSetup.LeftAxisMinimum = MinValue - v;
  GraphSetup.LeftAxisMaximum = MaxValue + v;
  //  ,      
  GraphSetup.LeftAxisMinimum = MinValue - v;
}

//------------------------------------------------------------
//    
// trend -  
// sql -  
//    
// ArcIndex -    1  99
// GraphIndex -  ,      0  9
//------------------------------------------------------------
bool MakeTrend(String & trend, String sql, Variant Parametrs, int ArcIndex, int GraphIndex)
{
  //     ,     (mask)
  String mask = "*:/\\\"><";
  for(int i=1; i<=Length(mask); i++)
    while( Pos(mask[i], trend)>0 )
      DeleteString(trend, Pos(mask[i], trend), 1);

  //       
  //      -    :
  // clUseServer=0 clUseClient=1
  if( SystemADOConnection1.CursorLocation==1 ) // clUseClient
  {
    SystemADOConnection1.Connected = false;
    SystemADOConnection1.CursorLocation = 0; // clUseServer
    //  TrendCreateFromSQL     
  }

  int rv = TrendCreateFromSQL(trend, ArcIndex, sql, Parametrs, SystemADOConnection1);

  //   :     ADO for ODBC --> PostgreSQL ODBC
  SystemADOConnection1.Connected = false;

  TrendValuesCount = rv;
  if( rv>=0 ) // SQL   
  {
    TrendAssign(trend, GraphIndex, ArcIndex);
  }
  else
  {
    LMShowMessage2("  SQL : " + TrendGetLastError(),
      szTrendErrorCaption, true, true);
    return false;
  }
  return true;
}

//------------------------------------------------------------
//      
// ArcIndex -    1  99
// TrendType  : 0-  1-  2- 
//      TrendStartTime, TrendEndTime
//------------------------------------------------------------
bool CalculateTrendTime(int ArcIndex, int TrendType)
{
  TDateTime stime;
  TDateTime etime;

  if( TrendFlatIntervalMode )
    //   
    switch( TrendType )
    {
      case 0: //  
      {
        if( ArcIndex==1 ) TrendStartTimePoint = Now();
        stime = TrendStartTimePoint - ArcIndex;
        etime = stime + 1;
      }
      case 1: //  
      {
        if( ArcIndex==1 ) TrendStartTimePoint = Now();
        stime = TrendStartTimePoint - (ArcIndex*7);
        etime = stime + 7;
      }
      case 2: //  
      {
        if( ArcIndex==1 ) TrendStartTimePoint = Now();
        stime = TrendStartTimePoint - (ArcIndex*31);
        etime = stime + 31;
      }
      default:
      {
        return false;
      }
    }
  else
    //  
    switch( TrendType )
    {
      case 0: //  
      {
        stime = Date() - ArcIndex + 1; //  ,  00:00:00

        if( ArcIndex==1 ) //  
          etime = Now(); //     ,    -  \
        else
          //etime = Date() - ArcIndex + 1 + EncodeTime(23,59,59,999); //  ( )
          etime = Date() - ArcIndex + 2; //  ( )
      }
      case 1: //  
      {
        stime = Date() - DayOfWeek(Date()) + 2 - 7 * (ArcIndex - 1); //  ,  00:00:00

        if( ArcIndex==1 ) //  
          etime = Now();
        else
          //etime = stime + 6 + EncodeTime(23,59,59,999);
          etime = stime + 7;
      }
      case 2: //  
      {
        //     SQL
        etime = Now(); //  \
        int pDay, pMonth, pYear;
        DecodeDate(etime, pYear, pMonth, pDay);
        pYear  -= Trunc(ArcIndex/12);
        pMonth -= ArcIndex - 1 - 12*Trunc(ArcIndex/12); //   
        //    ,     
        if( pMonth<=0 )
        {
          pMonth += 12;
          pYear  -= 1;
        }
        stime = EncodeDate(pYear, pMonth, 1); //   ,  00:00:00

        //      ,      
        if( ArcIndex==1 )
        {
          etime = Now(); //  
        }
        else
        {
          //    ,    , 
          //        .
          if( pMonth==12 )
          {
            pMonth = 1;
            pYear++;
          }
          else
          {
            pMonth++;
          }
          //etime = EncodeDate(pYear, pMonth, 1) - 1 + EncodeTime(23,59,59,999); //  
          etime = EncodeDate(pYear, pMonth, 1); //  
        }
      }
      default:
      {
        return false;
      }
    }

  TrendStartTime = stime;
  TrendEndTime = etime;
  return true;
}

//------------------------------------------------------------
//  1      lanmon
//------------------------------------------------------------
bool DrawTrend(WORD A1, WORD A2, WORD A3, WORD A4,
               int TrendType, String Template,
               int ArcIndex, int GraphIndex = 0,
               String Caption="")
{
  return Draw3Trend(A1, A2, A3, A4, 0, 0, TrendType, Template, ArcIndex, GraphIndex, Caption);
}

//------------------------------------------------------------
//  2      lanmon
//------------------------------------------------------------
bool Draw2Trend(WORD A1, WORD A2, WORD A3, WORD A4_1, WORD A4_2,
                int TrendType, String Template, int ArcIndex,
                int GraphIndex = 0, String Caption="")
{
  return Draw3Trend(A1, A2, A3, A4_1, A4_2, 0, TrendType, Template, ArcIndex, GraphIndex, Caption);
}

//------------------------------------------------------------
//  3      lanmon
//------------------------------------------------------------
bool Draw3Trend(WORD A1, WORD A2, WORD A3, WORD A4_1, WORD A4_2, WORD A4_3,
     int TrendType, String Template, int ArcIndex, int GraphIndex = 0, String Caption="")
{
  //   
  if( (A1==0) || (A2==0) || (A3==0) || (A4_1==0) )
  {
    LMShowMessage2("  : "+
      IntToStr(A1)+"."+IntToStr(A2)+"."+IntToStr(A3)+"."+IntToStr(A4_1),
      szTrendErrorCaption, true, true);
    return false;
  }

  if( ! CalculateTrendTime(ArcIndex, TrendType) )
  {
    LMShowMessage2("  : " + IntToStr(TrendType) + " !",
      szTrendErrorCaption, true, true);
    return false;
  }

  //    
  trendA1 = A1;
  trendA2 = A2;
  trendA3 = A3;
  trendA4_1 = A4_1;
  trendA4_2 = A4_2;
  trendA4_3 = A4_3;
  TrendTypeCurrent = TrendType;
  CustomTrendCaption = Caption;

  //     
  String TrendProto = LMWorkDir() + "trend.log";

  //       
  if( ArcIndex==1 )
  {
    TrendClear();
    //      \TREND\
    DeleteTrendFiles();
  }

  LMShowMessage("  , ...");
  String trend = LMFormatString(A1, A2, A3, A4_1, "%A4"); //  
  String sql = "SELECT DISTINCT res.rtime, res.val, res.state FROM get_values_for_graph(" +
               IntToStr(A1) + "," + IntToStr(A2) + "," + IntToStr(A3) + "," + IntToStr(A4_1) +
               ",timestamp'" + FormatDateTime("yyyy-mm-dd hh:mm:ss", TrendStartTime) +
               "',timestamp'" + FormatDateTime("yyyy-mm-dd hh:mm:ss", TrendEndTime) + "') AS res";

  LMProtokol(" : \"" + trend + "\" ArcIndex=" +
             IntToStr(ArcIndex) + " Template=" + Template, TrendProto);
  LMProtokol(sql, TrendProto);

  if( ! MakeTrend(trend, sql, NULL, ArcIndex, GraphIndex) )
  {
    LMProtokol("  : \"" + trend + "\" " + IntToStr(TrendValuesCount) + " !", TrendProto);
    LMShowMessage(""); //   
    return false;
  }
  LMProtokol("  ( " + IntToStr(TrendValuesCount) + " )", TrendProto);

  if( A4_2!=0 )
  {
    GraphIndex += 1;

    LMShowMessage("   2, ...");
    trend = LMFormatString(A1, A2, A3, A4_2, "%A4"); //  
    sql = "SELECT DISTINCT res.rtime, res.val, res.state FROM get_values_for_graph(" +
          IntToStr(A1) + "," + IntToStr(A2) + "," + IntToStr(A3) + "," + IntToStr(A4_2) +
          ",timestamp'" + FormatDateTime("yyyy-mm-dd hh:mm:ss", TrendStartTime) +
          "',timestamp'" + FormatDateTime("yyyy-mm-dd hh:mm:ss", TrendEndTime) + "') AS res";

    LMProtokol("  2: \"" + trend + "\" ArcIndex=" +
               IntToStr(ArcIndex) + " Template=" + Template, TrendProto);
    LMProtokol(sql, TrendProto);
    if( ! MakeTrend(trend, sql, NULL, ArcIndex, GraphIndex) )
    {
      LMProtokol("   2: \"" + trend + "\" " + IntToStr(TrendValuesCount) + " !", TrendProto);
      LMShowMessage("");
      return false;
    }
    LMProtokol(" 2  ( " + IntToStr(TrendValuesCount) + " )", TrendProto);
  }

  if( A4_3!=0 )
  {
    GraphIndex += 1;

    LMShowMessage("   3, ...");
    trend = LMFormatString(A1, A2, A3, A4_3, "%A4"); //  
    sql = "SELECT DISTINCT res.rtime, res.val, res.state FROM get_values_for_graph(" +
          IntToStr(A1) + "," + IntToStr(A2) + "," + IntToStr(A3) + "," + IntToStr(A4_3) +
          ",timestamp'" + FormatDateTime("yyyy-mm-dd hh:mm:ss", TrendStartTime) +
          "',timestamp'" + FormatDateTime("yyyy-mm-dd hh:mm:ss", TrendEndTime) + "') AS res";

    LMProtokol("  3: \"" + trend + "\" ArcIndex=" +
               IntToStr(ArcIndex) + " Template=" + Template, TrendProto);
    LMProtokol(sql, TrendProto);
    if( ! MakeTrend(trend, sql, NULL, ArcIndex, GraphIndex) )
    {
      LMProtokol("   3: \"" + trend + "\" " + IntToStr(TrendValuesCount) + " !", TrendProto);
      LMShowMessage("");
      return false;
    }
    LMProtokol(" 3  ( " + IntToStr(TrendValuesCount) + " )", TrendProto);
  }

  SetTrendCaption();
  LMShowMessage("");

  if( Length(Template) > 0 )
    if( ! TrendLoadParam(Template) )
      LMShowMessage2(TrendGetLastError(), szTrendErrorCaption, true, true);

  FormatValueAxis();
  TrendShowWindow(1);

  return true;
}

//------------------------------------------------------------
//         
//------------------------------------------------------------
void OnTrendWindowButtonClick(int Button, int ArcIndex)
{
  if( Button==1 ) //     
  {
    TrendClear();
    if( Draw3Trend(trendA1, trendA2, trendA3, trendA4_1, trendA4_2, trendA4_3,
                   TrendTypeCurrent, "", ArcIndex) )
    {
      SetTrendCaption();
    }
  }
  else if( Button==2 ) //     
  {
    if( ! CalculateTrendTime(ArcIndex, TrendTypeCurrent) )
    {
      LMShowMessage2("  : " + IntToStr(TrendTypeCurrent) + " !",
        szTrendErrorCaption, true, true);
      return;
    }
    SetTrendCaption();
  }

  FormatValueAxis();
  TrendShowWindow(1);
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
void SetTrendCaption()
{
  if( Length(CustomTrendCaption)>0 )
    TrendSetCaption( CustomTrendCaption +
                     "    " + DateTimeToStr(TrendStartTime) +
                     "  " + DateTimeToStr(TrendEndTime));
  else
  {
    if( (trendA4_2 != 0) && (trendA4_3 != 0) )
      TrendSetCaption( LMFormatString(trendA1, trendA2, trendA3, trendA4_1, "%A4, ") +
                       LMFormatString(trendA1, trendA2, trendA3, trendA4_2, "%A4, ") +
                       LMFormatString(trendA1, trendA2, trendA3, trendA4_3, "%A4") +
                       "    " + DateTimeToStr(TrendStartTime) +
                       "  " + DateTimeToStr(TrendEndTime));
    else if( trendA4_2 != 0 )
      TrendSetCaption( LMFormatString(trendA1, trendA2, trendA3, trendA4_1, "%A3.%A4, ") +
                       LMFormatString(trendA1, trendA2, trendA3, trendA4_2, "%A3.%A4") +
                       "    " + DateTimeToStr(TrendStartTime) +
                       "  " + DateTimeToStr(TrendEndTime));
    else
      TrendSetCaption( LMFormatString(trendA1, trendA2, trendA3, trendA4_1, "%A3.%A4") +
                       "    " + DateTimeToStr(TrendStartTime) +
                       "  " + DateTimeToStr(TrendEndTime));
  }
}

//------------------------------------------------------------
//     main()
//------------------------------------------------------------
{
}
